package j2d.filters.bufferedImageConvolution;

import gui.In;
import j2d.ImageUtils;
import j2d.ShortImageBean;

import java.awt.*;

import math.fourierTransforms.FFTShortImageBean;


public class FFTR2ImageConvolver implements ImageMatrixBeanProcessorInterface {
    private ImageMatrixBean imb;


    public Image process(Image image) {
        image = ImageUtils.cropImageToIntegralPowerOfTwo(image);
        ImageUtils.displayImage(image, "cropped image");
        final int w = image.getWidth(null);
        final int h = image.getHeight(null);
        Image kernalImage = imb.getImage(w, h);
        ImageUtils.displayImage(kernalImage, "kernal image");
        In.message("FFTR2ImageConvolver not done yet!");
        FFTShortImageBean f = new FFTShortImageBean(new ShortImageBean(image));
        f.forwardFFT();
        ImageUtils.displayImage(f.getPsdImage(),"psd of cropped input image");
        FFTShortImageBean k = new FFTShortImageBean(new ShortImageBean(kernalImage));
        k.forwardFFT();
        ImageUtils.displayImage(k.getPsdImage(),"psd of kernal image");
        //todo do the complex multiply here.
        k.normalize();
        //f.maskMult(k);
        return ImageUtils.getImage(f.ifft(),w,h);
    }

    public FFTR2ImageConvolver(ImageMatrixBean o) {
        this.imb = o;
    }

    public void setImageMatrixBean(ImageMatrixBean imb) {
        this.imb = imb;
    }

    public ImageMatrixBean getImageMatrixBean() {
        return imb;
    }
    public String toString(){
        return "FFTR2";
    }
}

